program demo;

{----------------------------------------------------------}
{-                                                        -}
{- Global type delcarations required for the procedures:  -}
{-                                                        -}
{-                 ColorMsg                               -}
{-                 WaitMsg                                -}
{-                 WriteSt                                -}
{-                 WriteStLn                              -}
{-                                                        -}
{----------------------------------------------------------}

Type
   Str255 = String[255];
   Str2   = String[2];
   TSet   = Set of 0..255;
   TMenu  = ^TM;
   TM     = Record
               Nxt,Prev : TMenu;
               XY       : Array[1..8,1..8] Of Byte;
               Items    : String[255];
               Desc     : Array[1..8] Of String[80];
            End;

{----------------------------------------------------------}
{- Global type and variable declarations for demo program -}
{----------------------------------------------------------}

Var
   Done  : Boolean;
   Ch    : Char;

{----------------------------------------------------------}
{-                                                        -}
{- External procedure declarations                        -}
{-                                                        -}
{----------------------------------------------------------}

Procedure BoarderColor(Color : Integer);                    External 'V1.ENH';
Procedure ClrWin;                                           External 'V2.ENH';
Procedure ColorMsg(X,Y,Color : Integer; Message : Str255);  External 'V3.ENH';
Procedure FillCol(X,Y,Num : Integer; Ch : Char);            External 'V4.ENH';
Procedure FillColAttrib(X,Y,Num,Color : Integer);           External 'V5.ENH';
Procedure FillRow(X,Y,Num : Integer; Ch : Char);            External 'V6.ENH';
Procedure FillRowAttrib(X,Y,Num,Color : Integer);           External 'V7.ENH';
Procedure FrameWin(UL,UR,LL,LR,Hor,Ver : Char);             External 'V8.ENH';
Procedure GetScrn(X,Y,NumChars : Integer; Var ChArray);     External 'V10.ENH';
Procedure GotoXYAbs(X,Y : Integer);                         External 'V12.ENH';
Procedure InitVideo(Mode : Integer);                        External 'V13.ENH';
Procedure PutScrn(X,Y,NumChars : Integer; Var ChArray);     External 'V14.ENH';
Procedure RvsVideo;                                         External 'V15.ENH';
Procedure ScrollDn(Lines,Color,X1,Y1,X2,Y2 : Integer);      External 'V16.ENH';
Procedure ScrollLeft(X1,Y1,X2,Y2,Cols,Color : Integer);  External 'V17.ENH';
Procedure ScrollUp(Lines,Color,X1,Y1,X2,Y2 : Integer);      External 'V18.ENH';
Procedure ScrollRight(Columns,Color,X1,Y1,X2,Y2 : Integer); External 'V19.ENH';
Procedure SetCursorSize(StartLine,EndLine : Integer);       External 'V20.ENH';
Procedure WaitMsg(X,Y   : Integer;     Msg : Str255;
                  TESet : TSet;    Var TE  : Integer);      External 'V21.ENH';
Procedure WriteSt(St : Str255);                             External 'V24.ENH';
Procedure WriteStLn(St : Str255);                           External 'V25.ENH';
Procedure EditSt(X,StY,SpY,Len,CM : Integer;
                      VCSet,TCSet : TSet;
                  Var TE          : Integer;
                  Var St                    );              External 'V26.ENH';

Function GetCursorSize : Integer;                           External 'V9.ENH';
Function GetVideoMode  : Integer;                           External 'V11.ENH';
Function WhereXAbs     : Integer;                           External 'V22.ENH';
Function WhereYAbs     : Integer;                           External 'V23.ENH';


Procedure DoBoarderColor;
Var
   Color : Integer;
Begin
   Repeat
      ClrScr;
      WriteStLn('Enter a value from 0-15 to see a boarder color');
      WriteSt('Enter a value >15 to quit ');
      Readln(Color);
      BoarderColor(Color);
   Until (Color < 0) Or (Color > 15);
   BoarderColor(0);
End;

Procedure DoColorMsg;
Var
   i : Integer;
Begin
   For i := 1 To 20 Do
      ColorMsg(10,i,i,'This is a message using color');
   ColorMsg(10,24,7,'Press [ENTER] to continue');
   Readln;
End;

Procedure DoFillCol;
Var
   i,j,k : Integer;
Begin
   j := 1;
   repeat
      ColorMsg(41,4,48,'                                    ');
      ColorMsg(41,5,48,'  Enter a value (1-40) to display   ');
      ColorMsg(41,6,48,'  a column of characters.           ');
      ColorMsg(41,7,48,'                                    ');
      ColorMsg(41,8,48,'  Any value not in range will exit  ');
      ColorMsg(41,9,48,'                                    ');
      GotoXYAbs(41,10);
      ClrEol;
      Readln(i);
      FillCol(i,1,25,Chr(64+j));
      If (i > 0) And (i < 41) Then Begin
            ColorMsg(41,4,48,'                                    ');
            ColorMsg(41,5,48,'  Enter a value (0-255) to display  ');
            ColorMsg(41,6,48,'  the color for the column of chars.');
            ColorMsg(41,7,48,'                                    ');
            ColorMsg(41,8,48,'  Any value not in range will exit  ');
            ColorMsg(41,9,48,'                                    ');
            GotoXYAbs(41,10);
            ClrEol;
            Readln(k);
            FillColAttrib(i,1,25,k);
            j := j + 1;
         End
      Else
         j := 26;
   Until (i < 0) Or (i > 40) Or (j > 25) Or (k < 0) Or (k > 255);
End;

Procedure DoFillRow;
Var
   i,j,k : Integer;
Begin
   j := 1;
   repeat
      ColorMsg(41,18,48,'                                    ');
      ColorMsg(41,19,48,'  Enter a value (1-25) to display   ');
      ColorMsg(41,20,48,'  a row of characters.              ');
      ColorMsg(41,21,48,'                                    ');
      ColorMsg(41,22,48,'  Any value not in range will exit  ');
      ColorMsg(41,23,48,'                                    ');
      GotoXYAbs(41,24);
      ClrEol;
      Readln(i);
      FillRow(1,i,80,Chr(64+j));
      If (i > 0) And (i < 26) Then Begin
            ColorMsg(41,18,48,'                                    ');
            ColorMsg(41,19,48,'  Enter a value (0-255) to display  ');
            ColorMsg(41,20,48,'  the color for the row of chars.   ');
            ColorMsg(41,21,48,'                                    ');
            ColorMsg(41,22,48,'  Any value not in range will exit  ');
            ColorMsg(41,23,48,'                                    ');
            GotoXYAbs(41,24);
            ClrEol;
            Readln(k);
            FillRowAttrib(1,i,80,k);
            j := j + 1;
         End
      Else
         j := 26;
   Until (i < 0) Or (i > 25) Or (j > 25) Or (k < 0) Or (k > 255);
End;

Procedure DoFrameWin;
Var
   i,j : Integer;
Begin
   For i := 1 To 10 Do Begin
      Window(i,i,80-i,25-i);
      FrameWin('','','','','','');
      ClrWin;
      GotoXY(1,1);
      For j := 1 to 20 do
         Writeln('This is window ',i:1);
      Writeln('Press [ENTER] to continue... ');
      Readln;
   End;
   Window(1,1,80,25);
End;

Procedure DoCursorSize;
Var
   i    : Integer;
   Done : Boolean;
Begin
   Done := False;
   Repeat
      ClrScr;
      WriteStLn('This routine demonstrates 3 Cursor sizes');
      WriteStLn('for use with the color/graphic adapter');
      WriteStLn(' ');
      WriteStLn('    0 - Normal');
      WriteStLn('    1 - Large');
      WriteStLn('    2 - Hidden');
      WriteStLn(' ');
      WriteStLn('Enter a value (0-3) for the size cursor you want ');
      WriteSt('Enter any value outside range to exit ');
      Readln(i);
      Case GetVideoMode Of
         7 : Case i Of
                0 : SetCursorSize(13,12);
                1 : SetCursorSize(13,0);
                2 : SetCursorSize(32,32);
             Else
                Done := True;
             End;
      Else
         Case i Of
            0 : SetCursorSize(7,6);
            1 : SetCursorSize(7,0);
            2 : SetCursorSize(32,32);
         Else
            Done := True;
         End;
      End;
      WriteStLn(' ');
      WriteStLn('The new cursor scan lines are:');
      WriteStLn(' ');
      WriteStLn('  Start Scan       Stop Scan');
      WriteStLn('  ----------       ---------');
      i := GetCursorSize;
      Writeln(Hi(i):7,Lo(i):17);
      WriteStLn(' ');
      WriteStLn('Press [ENTER] to continue... ');
      Readln;
   Until Done;
End;

Procedure DoScrn;
Var
   CA2 : Array[1..640] Of Char;
   TE  : Integer;
Begin
   WriteStLn('This is line 1 of the screen.  This line and the next 3 lines');
   WriteStLn('will be read from the screen and placed on lines 15-18');
   WriteStLn('All you will have to do is press the [ENTER] key to continue');
   WriteStLn('thru this procedure.');
   Readln;
   GetScrn(1,1,320,CA2);
   WaitMsg(1,6,
          'The screen has been read.  Press [ENTER] to continue... ',[13],TE);
   PutScrn(1,15,320,CA2);
   WaitMsg(1,7,'Press [ENTER] to exit this procedure',[13],TE);
End;

Procedure DoRvsVideo;
Var
   TE : Integer;
Begin
   WriteLn('This is how text is displayed before RvsVideo');
   WaitMsg(1,5,'Press [ESC] to continue...',[1],TE);
   RvsVideo;
   WriteLn('This is how text is displayed after RvsVideo');
   WaitMsg(1,5,'Press [ESC] to continue...',[1],TE);
   RvsVideo;
End;

Procedure DoScroll;
Var
   i  : Integer;
   Ch : Char;
Begin
   ClrScr;
   WriteStLn(' We will be scrolling the contents of window');
   WriteStLn(' either one column or row at a time');
   WriteStLn(' ');
   WriteStLn(' L - Scroll Left one column');
   WriteStLn(' R - Scroll Right one column');
   WriteStLn(' U - Scroll Up one row');
   WriteStLn(' D - Scroll Down one row');
   WriteStLn(' Q - Quit and return to menu');
   WriteStLn(' Press key for desired action');
   Window(48,1,80,25);
   FrameWin('','','','','','');
   For i := 49 To 79 Do
      FillCol(i,2,23,Chr(i+16));
   Repeat
      Read(Kbd,Ch);
      Ch := UpCase(Ch);
      Case Ch Of
         'L' : ScrollLeft (49,2,79,24,1,48);
         'R' : ScrollRight(49,2,79,24,1,48);
         'U' : ScrollUp   (49,2,79,24,1,7);
         'D' : ScrollDn   (49,2,79,24,1,7);
      End;
   Until Ch = 'Q';
   Window(1,1,80,25);
End;

Procedure DoCursorPos;
Var
   x,y : Integer;
Begin
   Window(54,9,80,14);
   FrameWin('','','','','','');
   Repeat
      ClrWin;
      ColorMsg(55,10,6,'                      ');
      ColorMsg(55,11,6,'Enter Column (1-40)   ');
      ColorMsg(55,12,6,'                      ');
      GotoXYAbs(75,11);
      Readln(x);
      ColorMsg(55,12,11,'Enter Row (1-25)      ');
      GotoXYAbs(72,12);
      Readln(y);
      GotoXYAbs(x,y);
      y := WhereXAbs;
      x := WhereYAbs;
      ClrWin;
      ColorMsg(55,11,1,'Press [ENTER] to continue');
      Readln;
      ClrScr;
      GotoXY(1,1);
      Writeln('The absolute column = ',y:1);
      Writeln('The absolure row    = ',x:1);
      ColorMsg(55,13,1,'Press [ENTER] to continue');
      GotoXYAbs(y,x);
      Readln;
   Until (x > 40) Or (x < 1) Or (y > 25) Or (y < 1);
   Window(1,1,80,25);
End;

Procedure DoVideoModes;
Var
   i,j : Integer;
   TE  : Integer;
Begin
   i := GetVideoMode;
   Gotoxy(5,10);
   Case i of
      0..6 : WriteStln('You have a color/graphics adapter card installed');
      7    : WriteStln('You use a monochrome monitor on your system');
   Else
      WriteStln('Enhance graphics adapter card installed?');
   End;
   Writeln;
   WriteStLn('Press [ENTER] to continue...');
   Readln;
   Writeln;
   WriteStln('Enter a value (0-7) for initializing a video mode');
   Readln(j);
   InitVideo(j);
   j := GetVideoMode;
   InitVideo(i);
   WriteSt('I initialized the video mode to number ');
   Writeln(j:1);
   WriteStln('I also returned you to the mode you were in before');
   WriteStln('I printed out the above statement.');
   WriteStln(' ');
   WaitMsg(1,25,'Press [ESC] to continue...',[1],TE);
End;

Procedure DoEditSt;
Var
   St    : Array[1..6] Of Str255;
   St1,St2   : Str255;
   TE    : Integer;
   TCS,
   TeCS,
   EdCS,
   VaCS  : TSet;
   i,CCM,
   TLen  : Integer;
   Info  : Array[1..5,1..6] Of Byte;
   Title : Array[1..6] Of String[10];
Begin
   TeCS := [13,60,71..81];
   TCS  := TeCS;
   EdCS := [1,13,60,72,80];
   VaCS := [32..255];    { ,65..90,97..122]; }
   CCM  := 1;
   FillChar(St,SizeOf(St),0);
   FillChar(St1,SizeOf(St1),0);
   FillChar(St2,SizeOf(St2),0);

   { Row           Start Col       Stop Col        Len           Case Mode }
   {------------  -------------  -------------  -------------  ----------- }
   Info[1,1]:=10; Info[2,1]:=10; Info[3,1]:=20; Info[4,1]:=25; Info[5,1]:=1;
   Info[1,2]:=12; Info[2,2]:=10; Info[3,2]:=25; Info[4,2]:=30; Info[5,2]:=1;
   Info[1,3]:=14; Info[2,3]:=10; Info[3,3]:=35; Info[4,3]:=15; Info[5,3]:=1;
   Info[1,4]:=10; Info[2,4]:=50; Info[3,4]:=51; Info[4,4]:= 2; Info[5,4]:=2;
   Info[1,5]:=12; Info[2,5]:=50; Info[3,5]:=55; Info[4,5]:= 5; Info[5,5]:=1;
   Info[1,6]:=14; Info[2,6]:=50; Info[3,6]:=75; Info[4,6]:=30; Info[5,6]:=3;
   Title[1] := 'Name   :';   Title[2] := 'Address:';
   Title[3] := 'City   :';   Title[4] := 'State  :';
   Title[5] := 'Zip    :';   Title[6] := 'Remarks:';
   ClrScr;
   Gotoxy(1,20);
   WriteStLn('This is a simple editting routine.  ');
   WriteStLn('Use the F2 key to enable editting keys');
   WriteStLn('Enter xxxxx to quit');
   ColorMsg(1,10,7,'Name   :');
   ColorMsg(1,12,7,'Address:');
   ColorMsg(1,14,7,'City   :');
   ColorMsg(40,10,7,'State   :');
   ColorMsg(40,12,7,'Zip     :');
   ColorMsg(40,14,7,'Remarks :');
   FillRow(1,3,80,'-');
   i := 1;
   ColorMsg(75,1,48,'READY');
   Repeat
      If TE <> 60 Then
         FillChar(St1,SizeOf(St1),0);
      FillRow(1,1,73,' ');
      FillRow(1,2,80,' ');
      St2 := Title[i] + ' ' + St[i];
      If Length(St2) > 73 Then
         St2[0] := chr(73);
      ColorMsg(1,1,7,St2);
      FillRowAttrib(Info[2,i],Info[1,i],Info[3,i]-Info[2,i]+1,48);
      EditSt(2,1,Info[4,i]+1,Info[4,i],Info[5,i],VaCS,TCS,TE,St1);
      FillRowAttrib(Info[2,i],Info[1,i],Info[3,i]-Info[2,i]+1,7);
      ColorMsg(75,1,48,'READY');
      TCS := TeCS;
      If (St1 <> '') And (TE <> 1) Then
         St[i] := St1;
      TLen := Ord(St[i][0]);
      If Ord(St[i][0]) > Info[3,i]-Info[2,i]+1 Then
         St[i][0] := Chr(Info[3,i] - Info[2,i] + 1);
      FillRow(Info[2,i],Info[1,i],Info[3,i]-Info[2,i]+1,' ');
      ColorMsg(Info[2,i],Info[1,i],7,St[i]);
      St[i][0] := Chr(TLen);
      Case TE Of
         71,73 : i := 1;
         72    : If i > 1 Then i := i - 1;
         75    : If i > 3 Then i := i - 3;
         77    : If i < 4 Then i := i + 3;
         79    : i := 6;
         13,80 : If i < 6 Then i := i + 1;
         60    : Begin
                    TCS := EdCS;
                    St1 := St[i];
                    ColorMsg(75,1,48,'EDIT ');
                 End;
      End;
   Until (St1 = 'XXXXX') Or (St1 = 'xxxxx');
End;


{--------------  Main Program ---------------------------}

Begin
   Done := False;
   TextColor(7);
   Repeat
      ClrScr;
      WriteStLn('   This menu is displayed using WriteStLn');
      WriteStLn(' ');
      WriteStLn('   Press a letter for the procedures to demonstrate');
      WriteStLn(' ');
      WriteStLn('      A.  BoarderColor, WriteSt');
      WriteStLn('      B.  FillCol, FillColAttrib, ColorMsg');
      WriteStLn('      C.  FillRow, FillRowAttrib, ColorMsg');
      WriteStLn('      D.  FrameWin, ClrWin');
      WriteStLn('      E.  GetCursorSize, SetCursorSize');
      WriteStLn('      F.  GetScrn, PutScrn');
      WriteStLn('      G.  RvsVideo');
      WriteStLn('      H.  ScrollLeft, ScrollRight, ScrollUp, ScrollDn');
      WriteStLn('      I.  GotoXYAbs, WhereXAbs, WhereYAbs');
      WriteStLn('      J.  InitVideo, GetVideoMode');
      WriteStLn('      K.  EditSt');
      WriteStLn(' ');
      WriteStLn('      M.  Quit this demo');
      WriteStLn(' ');
      Read(Kbd,Ch);
      Ch := UpCase(Ch);
      ClrScr;
      Case Ch Of
         'A' : DoBoarderColor;
         'B' : DoFillCol;
         'C' : DoFillRow;
         'D' : DoFrameWin;
         'E' : DoCursorSize;
         'F' : DoScrn;
         'G' : DoRvsVideo;
         'H' : DoScroll;
         'I' : DoCursorPos;
         'J' : DoVideoModes;
         'K' : DoEditSt;
         'M' : Done := True;
      End;
   Until Done;
   ClrScr;
End.
